import * as i6 from '@angular/cdk/scrolling';
import { ScrollingModule } from '@angular/cdk/scrolling';
import * as i6$1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Inject, ViewChildren } from '@angular/core';
import * as i2$1 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import * as i7 from '@angular/google-maps';
import { GoogleMapsModule } from '@angular/google-maps';
import * as i8 from '@angular/material/legacy-card';
import { MatLegacyCardModule } from '@angular/material/legacy-card';
import * as i1 from '@angular/material/legacy-dialog';
import { MAT_LEGACY_DIALOG_DATA, MatLegacyDialogModule } from '@angular/material/legacy-dialog';
import { MatLegacyTableModule } from '@angular/material/legacy-table';
import { MatSortModule } from '@angular/material/sort';
import * as i5$1 from '@angular/router';
import { FixedSizeVirtualScrollStrategy, RxVirtualScrollViewportComponent, RxVirtualFor } from '@rx-angular/template/experimental/virtual-scrolling';
import { RxFor } from '@rx-angular/template/for';
import { RxIf } from '@rx-angular/template/if';
import { RxLet } from '@rx-angular/template/let';
import { RxPush } from '@rx-angular/template/push';
import * as i3 from '@smallstack/common-components';
import { FlattenPipe, JsonByPathPipe, JsonStringPipe, LoadingElementDirective, ObjectArrayValuePipe, OverlayComponent, LongPressDirective, UppercaseSpacePipe, LetDirective, NgForTrackByIdDirective, RenderInViewportDirective, DebugComponentComponent, ScrollableDirective } from '@smallstack/common-components';
import * as i12 from '@smallstack/form-core-components';
import { SmallstackFormCoreModule } from '@smallstack/form-core-components';
import * as i2 from '@smallstack/i18n-components';
import { I18nComponent, CurrencyComponent, DateComponent, DurationComponent } from '@smallstack/i18n-components';
import { QRCodeDialogComponent } from '@smallstack/qrcode-components';
import * as i1$1 from '@smallstack/rx-components';
import { LoaderComponent, StorePropertyComponent, ListContainerComponent, MatSortStoreDirective } from '@smallstack/store-components';
import { MarkdownViewerComponent } from '@smallstack/text-components';
import { IconComponent } from '@smallstack/theme-components';
import * as i5 from '@smallstack/type-components';
import { ShowForPermissionDirective } from '@smallstack/user-components';
import { filterNullish, convertSortStringToAscDesc, flattenJson, removeNullish, sortStringWithNumbers, getJsonByPath, getSchemaPropertiesKeys, when, removeRequired, convertGeoPointToLatLng, convertToSortString, setJsonProperty, onlyUnique } from '@smallstack/utils';
import { WidgetTreeComponent, BaseWidgetComponent, WidgetTag, WidgetDialogComponent, WidgetChildComponent } from '@smallstack/widget-core';
import Fuse from 'fuse.js';
import { switchMap, take, shareReplay, map, of, BehaviorSubject, combineLatest, mergeMap, tap, debounce, interval, startWith, firstValueFrom } from 'rxjs';

class DataTableV3DialogComponent {
    constructor(data, dialogRef) {
        this.data = data;
        this.dialogRef = dialogRef;
        data.widgetRendererOptions.dialogRef = dialogRef;
    }
    close() {
        if (this.data.widgetRendererOptions?.editMode === true)
            this.dialogRef.close(this.data.cmsComponent);
        else
            this.dialogRef.close();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.7", ngImport: i0, type: DataTableV3DialogComponent, deps: [{ token: MAT_LEGACY_DIALOG_DATA }, { token: i1.MatLegacyDialogRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.7", type: DataTableV3DialogComponent, isStandalone: true, selector: "ng-component", ngImport: i0, template: "<div mat-dialog-content>\n  <smallstack-widget-tree\n    [(widget)]=\"data.cmsComponent\"\n    [widgetRendererOptions]=\"data.widgetRendererOptions\"\n    [context]=\"data.context\"\n  ></smallstack-widget-tree>\n</div>\n<div mat-dialog-actions class=\"flex flex-row justify-end\">\n  <button (click)=\"close()\" class=\"btn btn-primary\">\n    <smallstack-i18n data=\"@@actions.close\"></smallstack-i18n>\n  </button>\n</div>\n", styles: [".mat-dialog-content{height:calc(100% - 40px);max-height:unset}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "component", type: WidgetTreeComponent, selector: "smallstack-widget-tree", inputs: ["widgetRendererOptions", "widget", "context", "globals", "connections", "rootSockets"], outputs: ["connectionsChange", "widgetChange"] }, { kind: "component", type: I18nComponent, selector: "smallstack-i18n", inputs: ["data", "showMissingKey", "replacers", "locale", "translationStore"] }, { kind: "ngmodule", type: MatLegacyDialogModule }, { kind: "directive", type: i1.MatLegacyDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "directive", type: i1.MatLegacyDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.7", ngImport: i0, type: DataTableV3DialogComponent, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [CommonModule, WidgetTreeComponent, I18nComponent, MatLegacyDialogModule], template: "<div mat-dialog-content>\n  <smallstack-widget-tree\n    [(widget)]=\"data.cmsComponent\"\n    [widgetRendererOptions]=\"data.widgetRendererOptions\"\n    [context]=\"data.context\"\n  ></smallstack-widget-tree>\n</div>\n<div mat-dialog-actions class=\"flex flex-row justify-end\">\n  <button (click)=\"close()\" class=\"btn btn-primary\">\n    <smallstack-i18n data=\"@@actions.close\"></smallstack-i18n>\n  </button>\n</div>\n", styles: [".mat-dialog-content{height:calc(100% - 40px);max-height:unset}\n"] }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_LEGACY_DIALOG_DATA]
                }] }, { type: i1.MatLegacyDialogRef }]; } });

class DataTableV3WidgetComponent extends BaseWidgetComponent {
    constructor(matDialog, notificationService, routerUtilService, frontendTypeRegistry, breakPointService, rxCollectionService, viewportRuler, schemaService, activatedRoute) {
        super();
        this.matDialog = matDialog;
        this.notificationService = notificationService;
        this.routerUtilService = routerUtilService;
        this.frontendTypeRegistry = frontendTypeRegistry;
        this.breakPointService = breakPointService;
        this.rxCollectionService = rxCollectionService;
        this.viewportRuler = viewportRuler;
        this.schemaService = schemaService;
        this.activatedRoute = activatedRoute;
        this.collection$ = this.data$.pipe(filterNullish({ filterEmptyObjects: true }), switchMap((data) => {
            if (!data || !data.typeName)
                return undefined;
            return this.rxCollectionService.getCollection$(data.typeName);
        }), filterNullish(), take(1), switchMap(async (collection) => {
            if (!collection)
                return undefined;
            this.isLoading$.next(true);
            await collection.replicationState.awaitInSync();
            return collection;
        }), shareReplay());
        // data
        this.listProperties$ = this.data$.pipe(map((tableConfiguration) => {
            return tableConfiguration?.listProperties;
        }), shareReplay());
        this.columns$ = this.data$.pipe(filterNullish(), switchMap((tableConfiguration) => {
            if (!tableConfiguration.listProperties)
                return this.smallstackType$.pipe(map((type) => type?.searchableFields?.map((sf) => sf.name) ?? []));
            const columns = tableConfiguration.listProperties.map((lp) => lp.columnName);
            if (this.data?.showEditButton || this.data?.showDeleteButton)
                columns.push("actions");
            if (this.data?.allowMultiDelete || this.data?.showCheckboxes)
                columns.splice(0, 0, "multiSelect");
            return of(columns);
        }), shareReplay());
        this.userSorting$ = new BehaviorSubject(undefined);
        this.sorting$ = combineLatest([
            this.userSorting$,
            this.activatedRoute.queryParams.pipe(map((params) => params.sort)),
            this.data$.pipe(filterNullish(), map((data) => data.initialSortProperty))
        ]).pipe(map(([userSorting, urlSorting, initialSortProperty]) => {
            if (userSorting)
                return userSorting;
            if (urlSorting) {
                const sort = convertSortStringToAscDesc(urlSorting);
                return { propertyName: sort.key, direction: sort.direction };
            }
            else if (initialSortProperty) {
                const sort = convertSortStringToAscDesc(initialSortProperty);
                return { propertyName: sort.key, direction: sort.direction };
            }
            else
                return { propertyName: "id", direction: "asc" };
        }));
        this.totalCount$ = this.collection$.pipe(switchMap((collection) => collection.rxCollection.count().$), shareReplay());
        this.filterSearch$ = new BehaviorSubject(undefined);
        this.filterBarVisible$ = new BehaviorSubject(false);
        this.tableData$ = combineLatest([this.collection$, this.filterSearch$]).pipe(switchMap(([collection, filterSearch]) => {
            if (!collection)
                return [];
            let selector = undefined;
            if (filterSearch) {
                selector = flattenJson(filterSearch);
                selector = removeNullish(selector, { removeEmptyStrings: true });
            }
            if (selector)
                return collection.rxCollection.find({ selector }).$;
            else
                return collection.rxCollection.find().$;
        }), map((values) => values.map((val) => val.toJSON())), mergeMap((values) => combineLatest([of(values), this.sorting$, this.listProperties$])), map(([values, sorting, listProperties]) => {
            if (!sorting)
                return values;
            else {
                const sortingMode = listProperties?.find((lp) => lp.columnName === sorting.propertyName)?.sortingMode || "asStrings";
                if (sortingMode === "asNumbers")
                    return sortStringWithNumbers(values, { subProperty: sorting.propertyName, direction: sorting.direction });
                else
                    return values.sort((a, b) => {
                        const aProp = getJsonByPath(a, sorting.propertyName);
                        const bProp = getJsonByPath(b, sorting.propertyName);
                        if (aProp === undefined && bProp === undefined)
                            return 0;
                        if (typeof aProp === "string" && typeof bProp === "string")
                            return aProp?.localeCompare(bProp) * (sorting.direction === "asc" ? 1 : -1);
                        if (typeof aProp === "number" && typeof bProp === "number")
                            return (aProp - bProp) * (sorting.direction === "asc" ? 1 : -1);
                        if (aProp === undefined)
                            return sorting.direction === "asc" ? 1 : -1;
                        if (bProp === undefined)
                            return sorting.direction === "asc" ? -1 : 1;
                        return 0;
                    });
            }
        }), tap(() => this.isLoading$.next(false)), shareReplay());
        this.smallstackType$ = this.data$.pipe(map((tableConfiguration) => tableConfiguration?.typeName), filterNullish(), switchMap((typeName) => this.frontendTypeRegistry.getTypeByPath(typeName)), shareReplay());
        this.searchText$ = new BehaviorSubject(undefined);
        this.isSearching$ = new BehaviorSubject(false);
        this.searchResult$ = combineLatest([
            this.tableData$,
            this.searchText$.pipe(debounce(() => interval(800))),
            this.smallstackType$,
            this.collection$,
            this.sorting$
        ]).pipe(map(([values, searchText, smallstackType, collection, sorting]) => {
            // searching
            if (searchText) {
                this.isSearching$.next(true);
                this.isLoading$.next(true);
                let allProperties = [];
                if (smallstackType?.searchableFields instanceof Array && smallstackType.searchableFields.length > 0)
                    allProperties = smallstackType.searchableFields;
                else {
                    allProperties = getSchemaPropertiesKeys(collection.rxCollection.schema.jsonSchema).map((key) => {
                        return { name: key, weight: 10 };
                    });
                }
                const fuse = new Fuse(values.map((val) => val), {
                    keys: allProperties,
                    isCaseSensitive: false,
                    ignoreLocation: true,
                    includeScore: true,
                    shouldSort: sorting === undefined,
                    threshold: 0.3
                });
                const result = fuse.search(searchText).map((s) => ({
                    ...s.item,
                    score: when(s.score)
                        .is((s) => s < 0.0000001, () => "Sehr gut")
                        .is((s) => s < 0.0005, () => "Gut")
                        .is((s) => s < 0.005, () => "Mittel")
                        .is((s) => s < 0.1, () => "Ungenau")
                        .default(() => "Schlecht")
                }));
                this.isLoading$.next(false);
                this.isSearching$.next(false);
                return result;
            }
            this.isLoading$.next(false);
            return values;
        }), shareReplay());
        this.hasSearchResults$ = this.searchText$.pipe(map((searchText) => !!searchText));
        // state
        this.isLoading$ = new BehaviorSubject(true);
        this.isEmpty$ = this.tableData$.pipe(startWith(undefined), map((data) => !data));
        this.isMobile$ = this.breakPointService.isMobile$;
        this.selectedIds = [];
        this.filterSchema$ = this.data$.pipe(filterNullish(), switchMap(async () => {
            const schema = await this.schemaService.getSchemaByName(this.data.typeName);
            return this.schemaService.evalRefSchema(schema);
        }), map((schema) => removeRequired(schema)));
        this.containerWidth$ = new BehaviorSubject("100%");
        // google maps related stuff
        this.convertGeoPointToLatLng = convertGeoPointToLatLng;
        this.googleMapsOverlayOpened = false;
        this.errors = [];
        this.mappingArray = {};
        this.WidgetTag = WidgetTag;
    }
    ngAfterViewInit() {
        this.subscription.add(combineLatest([this.tableRows.changes, this.viewportRuler.change().pipe(startWith(undefined))]).subscribe(() => {
            const first = this.tableRows.first;
            if (first?.nativeElement) {
                this.containerWidth$.next(first.nativeElement.clientWidth + "px");
            }
        }));
    }
    async sort(propertyName, direction) {
        // set user sorting
        const currentSort = await firstValueFrom(this.sorting$);
        if (currentSort?.propertyName === propertyName && currentSort?.direction === direction) {
            this.userSorting$.next(undefined);
            // sync with url
            await this.routerUtilService.removeSearchParameter("sort");
        }
        else {
            this.userSorting$.next({ propertyName, direction });
            // sync with url
            await this.routerUtilService.addSearchParameter("sort", convertToSortString(propertyName, direction));
        }
    }
    async toggleSort(propertyName, isSortable) {
        if (isSortable) {
            const currentSort = await firstValueFrom(this.sorting$);
            if (currentSort?.propertyName === propertyName) {
                if (currentSort.direction === "asc")
                    await this.sort(propertyName, "desc");
                else
                    await this.sort(propertyName, "asc");
            }
            else
                await this.sort(propertyName, "asc");
        }
    }
    setInlineFilter(propertyName, element) {
        const value = getJsonByPath(element, propertyName);
        const current = this.filterSearch$.value;
        this.filterSearch$.next(setJsonProperty(current, propertyName, value));
        this.filterBarVisible$.next(true);
    }
    qrCodeDialog(value, prefix = "") {
        this.matDialog.closeAll();
        this.matDialog.open(QRCodeDialogComponent, { data: prefix + value, autoFocus: false });
    }
    async openDialog(lp, model) {
        this.matDialog.closeAll();
        if (lp.dialogUrlSyncParameter)
            await this.routerUtilService.addSearchParameter(lp.dialogUrlSyncParameter, model.id);
        void this.matDialog
            .open(DataTableV3DialogComponent, {
            width: lp.dialogWidth,
            height: lp.dialogHeight,
            autoFocus: false,
            data: {
                cmsComponent: lp.dialogComponent,
                widgetRendererOptions: {
                    editMode: this.editMode
                },
                context: model
            }
        })
            .afterClosed()
            .subscribe(async (component) => {
            if (this.editMode === true && component) {
                this.data.listProperties[lp.index].dialogComponent = component;
                this.dataChange.emit(this.data);
            }
            if (lp.dialogUrlSyncParameter)
                await this.routerUtilService.removeSearchParameter(lp.dialogUrlSyncParameter);
        });
    }
    openEditor(model) {
        return async () => {
            const data = await firstValueFrom(this.data$);
            const returnedModel = await this.frontendTypeRegistry.openEditor(data.typeName, model);
            if (returnedModel)
                await (await this.rxCollectionService.getCollection(data.typeName)).rxCollection.upsert(returnedModel);
        };
    }
    deleteData(elem) {
        return async () => {
            const answer = await this.notificationService.popup.confirmation("Datensatz löschen", "Soll der Datensatz wirklich gelöscht werden?", [
                { label: "@@actions.no", color: "primary", value: false },
                { label: "@@actions.yes", color: "error", value: true }
            ]);
            if (answer === true) {
                const data = await firstValueFrom(this.data$);
                const crud = this.frontendTypeRegistry.getCrud(data?.typeName);
                await crud.delete(elem.id);
                const collection = await this.rxCollectionService.getCollection(data?.typeName);
                await collection.rxCollection
                    .findOne(elem.id)
                    .exec()
                    .then((doc) => doc.remove());
            }
        };
    }
    deleteManyData(ids) {
        return async () => {
            const plural = ids.length !== 1;
            const answer = await this.notificationService.popup.confirmation(ids.length + " " + (plural ? "Datensätze" : "Datensatz") + " löschen", plural
                ? "Möchten Sie wirklich die " + ids.length + " selektierten Datensätze löschen?"
                : "Soll der Datensatz wirklich gelöscht werden?", [
                { label: "@@actions.no", classes: "btn btn-outline", value: false },
                { label: "@@actions.yes", classes: "btn btn-error", value: true }
            ]);
            if (answer === true) {
                const data = await firstValueFrom(this.data$);
                const crud = this.frontendTypeRegistry.getCrud(data?.typeName);
                await crud.deleteMany(ids);
                const collection = await this.rxCollectionService.getCollection(data?.typeName);
                for (const elem of ids)
                    await collection.rxCollection
                        .findOne(elem)
                        .exec()
                        .then((doc) => doc.remove());
                this.selectedIds = [];
            }
        };
    }
    exportData(selectedIds) {
        return async () => {
            const data = await firstValueFrom(this.searchResult$);
            const models = data.filter((d) => selectedIds.includes(d.id));
            const type = await firstValueFrom(this.smallstackType$);
            this.matDialog.open(WidgetDialogComponent, {
                panelClass: "no-mat-dialog-padding",
                width: "80vw",
                data: {
                    widget: {
                        name: "DataExportWidget",
                        data: {
                            models,
                            type,
                            schema: await this.schemaService.getSchemaByName(type.path)
                        }
                    }
                }
            });
        };
    }
    async toggleAll(checkboxEvent) {
        const target = checkboxEvent.target;
        const currentData = await firstValueFrom(this.tableData$);
        if (target.checked)
            this.selectedIds = currentData.map((data) => data.id);
        else
            this.selectedIds = [];
    }
    async toggleEntry(id, checkboxEvent) {
        const target = checkboxEvent.target;
        if (target.checked)
            this.selectedIds = onlyUnique([...this.selectedIds, id]);
        else
            this.selectedIds = this.selectedIds.filter((selectedId) => selectedId !== id);
    }
    /** callback fn for when a widget got set */
    async setWidgetListProperty(propertyName, newWidget) {
        const data = await firstValueFrom(this.data$);
        const index = data.listProperties?.findIndex((lp) => lp.property === propertyName);
        if (index === -1)
            throw new Error("Could not find list property by propertyName: " + propertyName);
        data.listProperties[index].widget = newWidget;
        this.dataChange.emit(data);
    }
    reload(forceCompleteReload) {
        return async () => {
            const collection = await firstValueFrom(this.collection$);
            if (forceCompleteReload)
                await collection.cleanAndResync();
            else
                await collection.sync();
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.7", ngImport: i0, type: DataTableV3WidgetComponent, deps: [{ token: i1.MatLegacyDialog }, { token: i2.NotificationService }, { token: i3.RouterUtilService }, { token: i5.FrontendTypeRegistry }, { token: i3.BreakpointService }, { token: i1$1.RxCollectionService }, { token: i6.ViewportRuler }, { token: i3.FrontendSchemaService }, { token: i5$1.ActivatedRoute }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.7", type: DataTableV3WidgetComponent, isStandalone: true, selector: "ng-component", viewQueries: [{ propertyName: "tableRows", predicate: ["rxTableRow"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<div *rxIf=\"data.showFullTextSearch !== false\" class=\"form-control m-2 mb-4\">\n  <div class=\"input-group\">\n    <input\n      #input\n      type=\"text\"\n      placeholder=\"Volltext Suche\"\n      class=\"input input-bordered w-full shadow-sm\"\n      (keyup)=\"searchText$.next($any($event.target).value)\"\n      (focus)=\"sendSocketData('focused')\"\n      [ngModel]=\"searchText$.value\"\n      data-testid=\"full-text-search\"\n    />\n    <button\n      *ngIf=\"searchText$.value\"\n      class=\"btn btn-square btn-warning shadow-sm\"\n      (click)=\"searchText$.next(undefined)\"\n    >\n      <smallstack-icon\n        name=\"trash\"\n        theme=\"fluency-systems-regular\"\n        themeColor=\"daisyTheme.warning.textColor\"\n        size=\"md\"\n      ></smallstack-icon>\n    </button>\n    <button class=\"btn btn-square btn-primary shadow-sm\" (click)=\"searchText$.next(input.value)\">\n      <span *rxIf=\"isLoading$; else icon\" class=\"loading loading-spinner\"></span>\n      <ng-template #icon>\n        <smallstack-icon\n          name=\"search\"\n          theme=\"fluency-systems-regular\"\n          themeColor=\"daisyTheme.primary.textColor\"\n          size=\"md\"\n        ></smallstack-icon>\n      </ng-template>\n    </button>\n  </div>\n</div>\n\n<ng-container *ngIf=\"errors?.length > 0\">\n  <div *ngFor=\"let error of errors\">\n    {{ error }}\n  </div>\n</ng-container>\n<ng-container *rxLet=\"searchResult$; let tableData\">\n  <ng-container *rxLet=\"data$; let tableConfiguration\">\n    <smallstack-loader *rxIf=\"isLoading$; else showTable\"></smallstack-loader>\n\n    <ng-template #showTable>\n      <ng-container\n        *ngIf=\"tableConfiguration && tableConfiguration.listProperties?.length > 0; else widgetNotConfigured\"\n      >\n        <div class=\"md:bordered md:shadow m-2\">\n          <div class=\"bg-slate-100 font-bold\">\n            <div class=\"hidden md:flex flex-row justify-evenly\" [ngStyle]=\"{ width: (containerWidth$ | push) }\">\n              <div class=\"rx-table-header-cell w-10\">\n                <input\n                  type=\"checkbox\"\n                  class=\"checkbox checkbox-primary checkbox-sm\"\n                  [indeterminate]=\"selectedIds.length !== tableData?.length && selectedIds.length !== 0\"\n                  [checked]=\"selectedIds.length === tableData.length\"\n                  (change)=\"toggleAll($event)\"\n                  data-test=\"check-all\"\n                />\n              </div>\n              <div *rxIf=\"hasSearchResults$\" class=\"rx-table-header-cell flex-[10] w-full\">\n                <span class=\"text-gray-800\">Such Relevanz</span>\n              </div>\n              <div\n                *rxFor=\"let listProperty of tableConfiguration.listProperties\"\n                class=\"rx-table-header-cell w-full overflow-hidden\"\n                [ngStyle]=\"{ flex: listProperty.width || 10 }\"\n              >\n                <div class=\"w-full flex flex-row justify-between items-center overflow-hidden\">\n                  <div class=\"flex-shrink overflow-hidden flex flex-row items-center\">\n                    <smallstack-i18n\n                      (click)=\"toggleSort(listProperty.property, listProperty.sortable)\"\n                      [data]=\"listProperty.title\"\n                      class=\"select-none overflow-hidden text-ellipsis\"\n                      [ngClass]=\"{ 'cursor-pointer': listProperty.sortable }\"\n                    ></smallstack-i18n>\n                    <ng-container *rxIf=\"sorting$; let sorting\">\n                      <div *rxIf=\"sorting.propertyName === listProperty.property\" class=\"w-4 h-4\">\n                        <smallstack-icon\n                          *rxIf=\"sorting.propertyName === listProperty.property && sorting.direction === 'asc'\"\n                          theme=\"fluency-systems-regular\"\n                          name=\"up--v1\"\n                          size=\"16\"\n                        ></smallstack-icon>\n                        <smallstack-icon\n                          *rxIf=\"sorting.propertyName === listProperty.property && sorting.direction === 'desc'\"\n                          theme=\"fluency-systems-regular\"\n                          name=\"down--v1\"\n                          size=\"16\"\n                        ></smallstack-icon>\n                      </div>\n                    </ng-container>\n                  </div>\n                  <div class=\"w-4 h-4 dropdown\" tabindex=\"0\">\n                    <smallstack-icon\n                      name=\"menu-2\"\n                      size=\"16\"\n                      theme=\"fluency-systems-regular\"\n                      class=\"cursor-pointer opacity-50 hover:opacity-100\"\n                    ></smallstack-icon>\n                    <div\n                      tabindex=\"0\"\n                      class=\"!fixed dropdown-content z-50 p-2 shadow-lg bg-base-100 rounded flex flex-col gap-2 border input-bordered justify-start items-start\"\n                    >\n                      <ng-container *rxIf=\"listProperty.sortable\">\n                        <button (click)=\"sort(listProperty.property, 'asc')\" class=\"btn btn-xs btn-block\">\n                          Aufsteigend sortieren\n                        </button>\n                        <button (click)=\"sort(listProperty.property, 'desc')\" class=\"btn btn-xs btn-block\">\n                          Absteigend sortieren\n                        </button>\n                      </ng-container>\n                      <button (click)=\"filterBarVisible$.next(true)\" class=\"btn btn-xs w- btn-block\">filtern</button>\n                    </div>\n                  </div>\n                </div>\n              </div>\n              <div class=\"rx-table-header-cell w-1/12\" style=\"min-width: 120px\">Actions</div>\n            </div>\n          </div>\n          <!-- Filter Bar -->\n          <smallstack-form\n            [ngClass]=\"{ hidden: !(filterBarVisible$ | push) }\"\n            [schema]=\"filterSchema$ | push\"\n            [value]=\"filterSearch$ | push\"\n            [options]=\"{ compactMode: true, showLabel: false, showHint: false }\"\n            (valueChange)=\"filterSearch$.next($event)\"\n          >\n            <smallstack-form-custom-layout>\n              <div\n                class=\"flex flex-row w-full rx-table-row rx-table-filter-row\"\n                [ngStyle]=\"{ width: (containerWidth$ | push) }\"\n              >\n                <div class=\"rx-table-cell w-10 center-center\"></div>\n                <div *rxIf=\"hasSearchResults$\" class=\"rx-table-cell flex-[10]\"></div>\n                <div\n                  *rxFor=\"let lp of tableConfiguration.listProperties\"\n                  class=\"rx-table-cell max-sm:flex-auto\"\n                  [ngStyle]=\"{ flex: lp.width || 10 }\"\n                >\n                  <ng-container *ngIf=\"lp.filterable\" [schemaFormPlaceholder]=\"lp.property\"></ng-container>\n                </div>\n                <div class=\"rx-table-cell w-1/12\" style=\"min-width: 120px\">\n                  <button\n                    class=\"btn btn-warning btn-sm\"\n                    (click)=\"filterSearch$.next(undefined); filterBarVisible$.next(false)\"\n                    >Filter l\u00F6schen</button\n                  >\n                </div>\n              </div>\n            </smallstack-form-custom-layout>\n          </smallstack-form>\n          <div\n            *ngIf=\"tableData === undefined || tableData === null || tableData.length === 0\"\n            class=\"text-center text-help m-6\"\n          >\n            Keine Daten vorhanden\n          </div>\n          <rx-virtual-scroll-viewport\n            style=\"min-height: 200px\"\n            [ngStyle]=\"{ height: tableConfiguration.tableHeight }\"\n            [itemSize]=\"64\"\n          >\n            <div\n              *rxVirtualFor=\"let element of tableData; let index = index; trackBy: 'id'\"\n              class=\"flex flex-col md:flex-row w-full rx-table-row max-md:card max-md:card-bordered\"\n              data-test=\"table-row\"\n              #rxTableRow\n            >\n              <div class=\"hidden md:block checkboxes rx-table-cell w-10\">\n                <input\n                  type=\"checkbox\"\n                  class=\"checkbox checkbox-primary checkbox-sm\"\n                  [checked]=\"selectedIds.includes(element.id)\"\n                  (change)=\"toggleEntry(element.id, $event)\"\n                  attr.data-testid=\"checkbox-{{ index }}\"\n                />\n              </div>\n              <div *rxIf=\"hasSearchResults$\" class=\"hidden md:block text-center rx-table-cell flex-[10]\">\n                <span class=\"text-help\">{{ element.score }}</span>\n              </div>\n              <div\n                *rxFor=\"let lp of tableConfiguration.listProperties\"\n                class=\"rx-table-cell max-sm:flex-auto relative\"\n                [ngStyle]=\"{ flex: lp.width || 10 }\"\n              >\n                <div *ngIf=\"lp.filterable\" class=\"absolute right-0 inline-filter invisible\">\n                  <smallstack-icon\n                    (click)=\"setInlineFilter(lp.property, element)\"\n                    name=\"filter\"\n                    class=\"opacity-60 cursor-pointer\"\n                  ></smallstack-icon>\n                </div>\n                <div class=\"font-bold mb-1 md:hidden\">\n                  <smallstack-i18n [data]=\"lp.title\"></smallstack-i18n>\n                </div>\n                <ng-container [ngSwitch]=\"lp.renderer\">\n                  <ng-container *ngSwitchCase=\"'date'\">\n                    <smallstack-date\n                      [format]=\"lp.rendererDateFormat\"\n                      [timestamp]=\"element | jsonByPath: lp.property\"\n                      style=\"white-space: nowrap\"\n                    ></smallstack-date>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'duration'\">\n                    <smallstack-duration [duration]=\"element | jsonByPath: lp.property\"></smallstack-duration>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'icon'\">\n                    <smallstack-icon\n                      size=\"24\"\n                      [alias]=\"\n                        mappingArray[lp.property][element[lp.property]]\n                          ? mappingArray[lp.property][element[lp.property]]\n                          : lp.defaultIcon\n                      \"\n                    ></smallstack-icon>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'image'\">\n                    <smallstack-overlay #overlay>\n                      <div class=\"card card-bordered card-compact shadow-xl bg-white\">\n                        <div class=\"card-body\">\n                          <img [src]=\"element | jsonByPath: lp.property\" class=\"w-100\" />\n                        </div>\n                      </div>\n                    </smallstack-overlay>\n                    <img\n                      class=\"mask mask-square w-16 cursor-pointer\"\n                      [src]=\"element | jsonByPath: lp.property\"\n                      (click)=\"overlay.openOverlay()\"\n                    />\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'storeProperty'\">\n                    <smallstack-store-property\n                      [storeName]=\"lp.rendererStorePropertyStore\"\n                      [property]=\"lp.rendererStorePropertyProperty\"\n                      [modelId]=\"element | flatten: lp.property\"\n                    >\n                    </smallstack-store-property>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'i18n'\">\n                    <ng-container *ngIf=\"lp.i18nPrefix; else unPrefixed\">\n                      <smallstack-i18n\n                        [data]=\"(lp.i18nPrefix ? lp.i18nPrefix : '') + element | jsonByPath: lp.property\"\n                      ></smallstack-i18n>\n                    </ng-container>\n                    <ng-template #unPrefixed>\n                      <smallstack-i18n [data]=\"element | jsonByPath: lp.property\"></smallstack-i18n>\n                    </ng-template>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'qrCode'\">\n                    <button class=\"btn-action\" (click)=\"qrCodeDialog(element[lp.property], lp.qrCodePrefix)\">\n                      <smallstack-icon alias=\"qrcode\"></smallstack-icon>\n                    </button>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'dialog'\">\n                    <button class=\"btn-action\" (click)=\"openDialog(lp, element)\">\n                      <smallstack-icon [name]=\"lp.dialogButtonIcon\"></smallstack-icon>\n                    </button>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'link'\">\n                    <a\n                      href=\"{{ element | jsonByPath: lp.property }}\"\n                      target=\"{{ lp.openLinkInNewWindow ? '_blank' : undefined }}\"\n                    >\n                      <ng-container *ngIf=\"lp.linkLabel; else noLabel\">\n                        {{ lp.linkLabel }}\n                      </ng-container>\n                      <ng-template #noLabel>\n                        {{ element | jsonByPath: lp.property }}\n                      </ng-template>\n                    </a>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'boolean'\">\n                    <smallstack-icon\n                      name=\"checkmark--v1\"\n                      theme=\"color\"\n                      size=\"24\"\n                      *ngIf=\"(element | jsonByPath: lp.property) === true; else falsy\"\n                    >\n                    </smallstack-icon>\n                    <ng-template #falsy>\n                      <smallstack-icon name=\"delete-sign--v1\" theme=\"color\" size=\"24\"> </smallstack-icon>\n                    </ng-template>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'markdown'\">\n                    <smallstack-markdown-viewer [text]=\"element | jsonByPath: lp.property\"></smallstack-markdown-viewer>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'googleMap'\">\n                    <div style=\"cursor: pointer; position: relative\" (click)=\"overlay.openOverlay()\">\n                      <div style=\"position: absolute; width: 100%; height: 100%; z-index: 100\"></div>\n                      <google-map\n                        [width]=\"lp.googleMapsPreviewWidth\"\n                        [height]=\"lp.googleMapsPreviewHeight\"\n                        [zoom]=\"14\"\n                        [center]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                        [options]=\"{\n                          gestureHandling: 'none',\n                          disableDefaultUI: true,\n                          styles: [\n                            {\n                              featureType: 'poi',\n                              elementType: 'labels',\n                              stylers: [{ visibility: 'off' }]\n                            }\n                          ]\n                        }\"\n                      >\n                        <map-marker\n                          [position]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                          [clickable]=\"false\"\n                        ></map-marker>\n                      </google-map>\n                    </div>\n                    <smallstack-overlay #overlay>\n                      <mat-card class=\"flex flex-col space-y-5\">\n                        <google-map\n                          width=\"350px\"\n                          height=\"350px\"\n                          [zoom]=\"16\"\n                          [center]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                        >\n                          <map-marker\n                            [position]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                            [clickable]=\"false\"\n                          ></map-marker>\n                        </google-map>\n                        <button class=\"btn btn-primary\" (click)=\"overlay.closeOverlay()\">\n                          <smallstack-i18n data=\"@@actions.close\"></smallstack-i18n>\n                        </button>\n                      </mat-card>\n                    </smallstack-overlay>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'widget'\">\n                    <ng-container *ngIf=\"lp.widget\">\n                      <smallstack-widget-tree\n                        *ngIf=\"lp.widgetContextType === 'full'; else propertyContext\"\n                        [widget]=\"lp.widget\"\n                        (widgetChange)=\"setWidgetListProperty(lp.property, $event)\"\n                        [widgetRendererOptions]=\"{\n                          editMode$: widgetTreeService.editMode$\n                        }\"\n                        [context]=\"{ model: element }\"\n                        [globals]=\"{ model: element }\"\n                      ></smallstack-widget-tree>\n                      <ng-template #propertyContext>\n                        <smallstack-widget-tree\n                          [widget]=\"lp.widget\"\n                          (widgetChange)=\"setWidgetListProperty(lp.property, $event)\"\n                          [widgetRendererOptions]=\"{\n                            editMode$: widgetTreeService.editMode$\n                          }\"\n                          [context]=\"{ model: element | jsonByPath: lp.property }\"\n                          [globals]=\"{ model: element }\"\n                        ></smallstack-widget-tree\n                      ></ng-template>\n                    </ng-container>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'currency'\">\n                    <smallstack-currency\n                      [iso]=\"lp.currency ? lp.currency : 'EUR'\"\n                      [cents]=\"element[lp.property]\"\n                    ></smallstack-currency>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'valueMapping'\">\n                    <span>{{\n                      lp.mappingArray | objectArrayValue: \"value\":element[lp.property]:\"mappedValue\":lp.defaultValue\n                    }}</span>\n                  </ng-container>\n                  <ng-container *ngSwitchDefault>\n                    {{ element | flatten: lp.property | jsonstring }}\n                  </ng-container>\n                </ng-container>\n              </div>\n\n              <div class=\"flex flex-row gap-2 rx-table-cell w-1/12 flex-wrap items-center\" style=\"min-width: 120px\">\n                <ng-container *ngIf=\"data?.showDeleteButton\">\n                  <button\n                    class=\"btn-action btn-error\"\n                    [loadingFn]=\"deleteData(element)\"\n                    *showForPermission=\"(smallstackType$ | push)?.permissions?.delete\"\n                    data-test=\"delete-entry\"\n                  >\n                    <smallstack-icon alias=\"delete\"></smallstack-icon>\n                  </button>\n                </ng-container>\n                <ng-container *ngIf=\"data?.showEditButton\">\n                  <button\n                    class=\"btn-action btn-primary\"\n                    [loadingFn]=\"openEditor(element)\"\n                    *showForPermission=\"(smallstackType$ | push)?.permissions?.update\"\n                    data-test=\"edit-entry\"\n                  >\n                    <smallstack-icon alias=\"edit\"></smallstack-icon>\n                  </button>\n                </ng-container>\n                <smallstack-widget-child\n                  [(data)]=\"data\"\n                  property=\"actionWidget\"\n                  [context]=\"{ model: element }\"\n                  (dataChange)=\"dataChange.emit($event)\"\n                ></smallstack-widget-child>\n              </div>\n            </div>\n          </rx-virtual-scroll-viewport>\n        </div>\n        <div class=\"flex flex-row justify-between items-center w-full px-2 rx-table-actions\">\n          <!-- selected id actions -->\n          <div class=\"flex flex-row justify-start relative\">\n            <div\n              *rxIf=\"selectedIds.length === 0\"\n              class=\"absolute w-full h-full top-0 left-0 z-50 bg-white opacity-80 cursor-not-allowed\"\n            ></div>\n            <div *ngIf=\"data.allowMultiDelete\" class=\"flex flex-row justify-start items-center gap-2\">\n              <button\n                class=\"btn btn-error flex flex-row gap-1 items-center text-white\"\n                [loadingFn]=\"deleteManyData(selectedIds)\"\n                matTooltip=\"Markierte Datens\u00E4tze l\u00F6schen\"\n                *showForPermission=\"(smallstackType$ | push)?.permissions?.delete\"\n              >\n                <smallstack-icon\n                  alias=\"delete\"\n                  theme=\"fluency-systems-regular\"\n                  themeColor=\"daisyTheme.primary.textColor\"\n                ></smallstack-icon>\n                <smallstack-i18n data=\"@@actions.delete\"></smallstack-i18n>\n              </button>\n              <ng-container *rxIf=\"data.showExportButton !== false\">\n                <button\n                  class=\"btn btn-primary flex flex-row gap-1 items-center text-white\"\n                  [loadingFn]=\"exportData(selectedIds)\"\n                  matTooltip=\"Markierte Datens\u00E4tze exportieren\"\n                  *showForPermission=\"(smallstackType$ | push)?.permissions?.readAll\"\n                >\n                  <smallstack-icon\n                    name=\"export\"\n                    theme=\"fluency-systems-regular\"\n                    themeColor=\"daisyTheme.primary.textColor\"\n                  ></smallstack-icon>\n                  <smallstack-i18n data=\"@@actions.export\"></smallstack-i18n>\n                </button>\n              </ng-container>\n            </div>\n            <smallstack-widget-child\n              property=\"listActionsComponent\"\n              [(data)]=\"data\"\n              [context]=\"{selectedIds}\"\n              [widgetTags]=\"[WidgetTag.ICON, WidgetTag.CONTAINER]\"\n              (dataChange)=\"dataChange.emit($event)\"\n            ></smallstack-widget-child>\n          </div>\n          <!-- information -->\n          <div class=\"justify-center items-center text-help\" *rxLet=\"totalCount$; let totalCount\">\n            {{ totalCount }} Datens\u00E4tze insgesamt<span\n              *rxIf=\"totalCount !== tableData.length || hasSearchResults$ || filterSearch$\"\n            >\n              | {{ tableData.length }} Such-/ Filterergebnisse</span\n            ><span *ngIf=\"selectedIds?.length > 0\"> | {{ selectedIds.length }} markiert</span></div\n          >\n          <div class=\"flex flex-row gap-2\">\n            <button\n              class=\"btn btn-primary flex flex-row gap-1 items-center\"\n              [loadingFn]=\"reload(false)\"\n              (longPress)=\"reload(true)()\"\n              data-test=\"reload\"\n            >\n              <smallstack-icon\n                alias=\"refresh\"\n                theme=\"fluency-systems-regular\"\n                themeColor=\"daisyTheme.primary.textColor\"\n              ></smallstack-icon>\n              <smallstack-i18n data=\"@@actions.reload\"></smallstack-i18n>\n            </button>\n            <ng-container *showForPermission=\"(smallstackType$ | push)?.permissions?.create\">\n              <button\n                *ngIf=\"tableConfiguration?.showCreateButton !== false\"\n                class=\"btn btn-primary flex flex-row gap-1 items-center\"\n                [loadingFn]=\"openEditor()\"\n                data-test=\"create\"\n              >\n                <smallstack-icon\n                  alias=\"plus\"\n                  theme=\"fluency-systems-regular\"\n                  themeColor=\"daisyTheme.primary.textColor\"\n                ></smallstack-icon>\n                <smallstack-i18n data=\"@@actions.create\"></smallstack-i18n>\n              </button>\n            </ng-container>\n          </div>\n        </div>\n      </ng-container>\n    </ng-template>\n  </ng-container>\n</ng-container>\n<ng-template #widgetNotConfigured>\n  <div style=\"height: 60px\" class=\"flex flex-col justify-center items-center\">\n    <i><smallstack-i18n data=\"@@widgets.dataTable.errors.notConfiguredYet\"></smallstack-i18n></i>\n  </div>\n</ng-template>\n", styles: [".rx-table-header-cell{@apply p-2 pr-0 flex flex-row justify-start items-center overflow-hidden border-r border-r-white transition-all duration-500;}.rx-table-cell{overflow:hidden;flex-wrap:wrap;@apply p-2 h-16 flex items-center hover:bg-slate-100;}.rx-table-cell:hover .inline-filter{@apply visible;}.rx-table-row:nth-child(even){@apply bg-slate-50;}.rx-table-filter-row .rx-table-cell{@apply p-1;}.rx-table-filter-row ::ng-deep .input{@apply input-sm;}.rx-table-filter-row ::ng-deep .btn{@apply btn-sm;}.rx-table-filter-row ::ng-deep .dropdown-content{@apply fixed;}.rx-table-actions ::ng-deep .btn{@apply btn-sm;}.filter-bar-grid{display:grid;grid-template-columns:repeat(auto-fill,minmax(250px,1fr));grid-gap:10px}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i6$1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i6$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i6$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i6$1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i6$1.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i6$1.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i6$1.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: CurrencyComponent, selector: "smallstack-currency", inputs: ["iso", "value", "euros", "cents"] }, { kind: "component", type: DateComponent, selector: "smallstack-date", inputs: ["timestamp", "format"] }, { kind: "component", type: DurationComponent, selector: "smallstack-duration", inputs: ["start", "end", "duration"] }, { kind: "pipe", type: FlattenPipe, name: "flatten" }, { kind: "ngmodule", type: GoogleMapsModule }, { kind: "component", type: i7.GoogleMap, selector: "google-map", inputs: ["height", "width", "mapTypeId", "center", "zoom", "options"], outputs: ["mapInitialized", "authFailure", "boundsChanged", "centerChanged", "mapClick", "mapDblclick", "mapDrag", "mapDragend", "mapDragstart", "headingChanged", "idle", "maptypeidChanged", "mapMousemove", "mapMouseout", "mapMouseover", "projectionChanged", "mapRightclick", "tilesloaded", "tiltChanged", "zoomChanged"], exportAs: ["googleMap"] }, { kind: "directive", type: i7.MapMarker, selector: "map-marker", inputs: ["title", "position", "label", "clickable", "options", "icon", "visible"], outputs: ["animationChanged", "mapClick", "clickableChanged", "cursorChanged", "mapDblclick", "mapDrag", "mapDragend", "draggableChanged", "mapDragstart", "flatChanged", "iconChanged", "mapMousedown", "mapMouseout", "mapMouseover", "mapMouseup", "positionChanged", "mapRightclick", "shapeChanged", "titleChanged", "visibleChanged", "zindexChanged"], exportAs: ["mapMarker"] }, { kind: "component", type: I18nComponent, selector: "smallstack-i18n", inputs: ["data", "showMissingKey", "replacers", "locale", "translationStore"] }, { kind: "component", type: IconComponent, selector: "smallstack-icon", inputs: ["theme", "size", "name", "alias", "action", "actionSize", "spinning", "actionSpinning", "color", "themeColor", "actionColor", "badge", "dynamic", "badgeColor"], outputs: ["iconError"] }, { kind: "pipe", type: JsonByPathPipe, name: "jsonByPath" }, { kind: "pipe", type: JsonStringPipe, name: "jsonstring" }, { kind: "component", type: LoaderComponent, selector: "smallstack-loader", inputs: ["loading", "color", "size", "loadingText"] }, { kind: "directive", type: LoadingElementDirective, selector: "[loadingFn]", inputs: ["loadingFn", "isLoading"], exportAs: ["loadingFn"] }, { kind: "component", type: MarkdownViewerComponent, selector: "smallstack-markdown-viewer", inputs: ["text"] }, { kind: "ngmodule", type: MatLegacyCardModule }, { kind: "component", type: i8.MatLegacyCard, selector: "mat-card", exportAs: ["matCard"] }, { kind: "ngmodule", type: MatLegacyTableModule }, { kind: "ngmodule", type: MatSortModule }, { kind: "pipe", type: ObjectArrayValuePipe, name: "objectArrayValue" }, { kind: "component", type: OverlayComponent, selector: "smallstack-overlay" }, { kind: "component", type: StorePropertyComponent, selector: "smallstack-store-property", inputs: ["store", "storeName", "modelId", "property", "notFound", "showNotFound"] }, { kind: "component", type: WidgetChildComponent, selector: "smallstack-widget-child", inputs: ["data", "context", "property", "widgetTags"], outputs: ["dataChange"] }, { kind: "component", type: WidgetTreeComponent, selector: "smallstack-widget-tree", inputs: ["widgetRendererOptions", "widget", "context", "globals", "connections", "rootSockets"], outputs: ["connectionsChange", "widgetChange"] }, { kind: "directive", type: ShowForPermissionDirective, selector: "[showForPermission]", inputs: ["showForPermission", "showForPermissionTenantId"] }, { kind: "ngmodule", type: ScrollingModule }, { kind: "pipe", type: RxPush, name: "push" }, { kind: "directive", type: RxFor, selector: "[rxFor][rxForOf]", inputs: ["rxForOf", "rxForTemplate", "rxForStrategy", "rxForParent", "rxForPatchZone", "rxForTrackBy", "rxForRenderCallback"] }, { kind: "directive", type: RxLet, selector: "[rxLet]", inputs: ["rxLet", "rxLetStrategy", "rxLetComplete", "rxLetError", "rxLetSuspense", "rxLetContextTrigger", "rxLetCompleteTrigger", "rxLetErrorTrigger", "rxLetSuspenseTrigger", "rxLetNextTrigger", "rxLetRenderCallback", "rxLetParent", "rxLetPatchZone"], outputs: ["rendered"] }, { kind: "directive", type: RxIf, selector: "[rxIf]", inputs: ["rxIf", "rxIfStrategy", "rxIfElse", "rxIfThen", "rxIfSuspense", "rxIfComplete", "rxIfError", "rxIfContextTrigger", "rxIfNextTrigger", "rxIfSuspenseTrigger", "rxIfErrorTrigger", "rxIfCompleteTrigger", "rxIfParent", "rxIfPatchZone", "rxIfRenderCallback"] }, { kind: "directive", type: FixedSizeVirtualScrollStrategy, selector: "rx-virtual-scroll-viewport[itemSize]", inputs: ["itemSize", "runwayItems", "runwayItemsOpposite"] }, { kind: "component", type: RxVirtualScrollViewportComponent, selector: "rx-virtual-scroll-viewport", outputs: ["viewRange", "scrolledIndexChange"] }, { kind: "directive", type: RxVirtualFor, selector: "[rxVirtualFor][rxVirtualForOf]", inputs: ["rxVirtualForOf", "rxVirtualForTemplate", "rxVirtualForStrategy", "rxVirtualForTemplateCacheSize", "rxVirtualForParent", "rxVirtualForPatchZone", "rxVirtualForTrackBy", "rxVirtualForRenderCallback"] }, { kind: "ngmodule", type: SmallstackFormCoreModule }, { kind: "component", type: i12.SchemaFormLayoutCustomComponent, selector: "schema-form-custom-layout,smallstack-schema-form-custom-layout,smallstack-form-custom-layout" }, { kind: "directive", type: i12.SchemaFormPlaceholderDirective, selector: "[schemaFormPlaceholder]", inputs: ["schemaFormPlaceholder"] }, { kind: "component", type: i12.FormComponent, selector: "smallstack-form", inputs: ["schema", "options", "value"], outputs: ["valueChange", "submitForm"] }, { kind: "directive", type: LongPressDirective, selector: "[longPress]", inputs: ["duration"], outputs: ["longPress"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.7", ngImport: i0, type: DataTableV3WidgetComponent, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [
                        CommonModule,
                        FormsModule,
                        CurrencyComponent,
                        DateComponent,
                        DurationComponent,
                        FlattenPipe,
                        GoogleMapsModule,
                        I18nComponent,
                        IconComponent,
                        JsonByPathPipe,
                        JsonStringPipe,
                        ListContainerComponent,
                        LoaderComponent,
                        LoadingElementDirective,
                        MarkdownViewerComponent,
                        MatLegacyCardModule,
                        MatLegacyTableModule,
                        MatSortModule,
                        MatSortStoreDirective,
                        ObjectArrayValuePipe,
                        OverlayComponent,
                        StorePropertyComponent,
                        UppercaseSpacePipe,
                        WidgetChildComponent,
                        WidgetTreeComponent,
                        ShowForPermissionDirective,
                        LetDirective,
                        MatSortModule,
                        NgForTrackByIdDirective,
                        ScrollingModule,
                        RenderInViewportDirective,
                        RxPush,
                        RxFor,
                        RxLet,
                        RxIf,
                        DebugComponentComponent,
                        FixedSizeVirtualScrollStrategy,
                        RxVirtualScrollViewportComponent,
                        RxVirtualFor,
                        ScrollableDirective,
                        SmallstackFormCoreModule,
                        LongPressDirective
                    ], template: "<div *rxIf=\"data.showFullTextSearch !== false\" class=\"form-control m-2 mb-4\">\n  <div class=\"input-group\">\n    <input\n      #input\n      type=\"text\"\n      placeholder=\"Volltext Suche\"\n      class=\"input input-bordered w-full shadow-sm\"\n      (keyup)=\"searchText$.next($any($event.target).value)\"\n      (focus)=\"sendSocketData('focused')\"\n      [ngModel]=\"searchText$.value\"\n      data-testid=\"full-text-search\"\n    />\n    <button\n      *ngIf=\"searchText$.value\"\n      class=\"btn btn-square btn-warning shadow-sm\"\n      (click)=\"searchText$.next(undefined)\"\n    >\n      <smallstack-icon\n        name=\"trash\"\n        theme=\"fluency-systems-regular\"\n        themeColor=\"daisyTheme.warning.textColor\"\n        size=\"md\"\n      ></smallstack-icon>\n    </button>\n    <button class=\"btn btn-square btn-primary shadow-sm\" (click)=\"searchText$.next(input.value)\">\n      <span *rxIf=\"isLoading$; else icon\" class=\"loading loading-spinner\"></span>\n      <ng-template #icon>\n        <smallstack-icon\n          name=\"search\"\n          theme=\"fluency-systems-regular\"\n          themeColor=\"daisyTheme.primary.textColor\"\n          size=\"md\"\n        ></smallstack-icon>\n      </ng-template>\n    </button>\n  </div>\n</div>\n\n<ng-container *ngIf=\"errors?.length > 0\">\n  <div *ngFor=\"let error of errors\">\n    {{ error }}\n  </div>\n</ng-container>\n<ng-container *rxLet=\"searchResult$; let tableData\">\n  <ng-container *rxLet=\"data$; let tableConfiguration\">\n    <smallstack-loader *rxIf=\"isLoading$; else showTable\"></smallstack-loader>\n\n    <ng-template #showTable>\n      <ng-container\n        *ngIf=\"tableConfiguration && tableConfiguration.listProperties?.length > 0; else widgetNotConfigured\"\n      >\n        <div class=\"md:bordered md:shadow m-2\">\n          <div class=\"bg-slate-100 font-bold\">\n            <div class=\"hidden md:flex flex-row justify-evenly\" [ngStyle]=\"{ width: (containerWidth$ | push) }\">\n              <div class=\"rx-table-header-cell w-10\">\n                <input\n                  type=\"checkbox\"\n                  class=\"checkbox checkbox-primary checkbox-sm\"\n                  [indeterminate]=\"selectedIds.length !== tableData?.length && selectedIds.length !== 0\"\n                  [checked]=\"selectedIds.length === tableData.length\"\n                  (change)=\"toggleAll($event)\"\n                  data-test=\"check-all\"\n                />\n              </div>\n              <div *rxIf=\"hasSearchResults$\" class=\"rx-table-header-cell flex-[10] w-full\">\n                <span class=\"text-gray-800\">Such Relevanz</span>\n              </div>\n              <div\n                *rxFor=\"let listProperty of tableConfiguration.listProperties\"\n                class=\"rx-table-header-cell w-full overflow-hidden\"\n                [ngStyle]=\"{ flex: listProperty.width || 10 }\"\n              >\n                <div class=\"w-full flex flex-row justify-between items-center overflow-hidden\">\n                  <div class=\"flex-shrink overflow-hidden flex flex-row items-center\">\n                    <smallstack-i18n\n                      (click)=\"toggleSort(listProperty.property, listProperty.sortable)\"\n                      [data]=\"listProperty.title\"\n                      class=\"select-none overflow-hidden text-ellipsis\"\n                      [ngClass]=\"{ 'cursor-pointer': listProperty.sortable }\"\n                    ></smallstack-i18n>\n                    <ng-container *rxIf=\"sorting$; let sorting\">\n                      <div *rxIf=\"sorting.propertyName === listProperty.property\" class=\"w-4 h-4\">\n                        <smallstack-icon\n                          *rxIf=\"sorting.propertyName === listProperty.property && sorting.direction === 'asc'\"\n                          theme=\"fluency-systems-regular\"\n                          name=\"up--v1\"\n                          size=\"16\"\n                        ></smallstack-icon>\n                        <smallstack-icon\n                          *rxIf=\"sorting.propertyName === listProperty.property && sorting.direction === 'desc'\"\n                          theme=\"fluency-systems-regular\"\n                          name=\"down--v1\"\n                          size=\"16\"\n                        ></smallstack-icon>\n                      </div>\n                    </ng-container>\n                  </div>\n                  <div class=\"w-4 h-4 dropdown\" tabindex=\"0\">\n                    <smallstack-icon\n                      name=\"menu-2\"\n                      size=\"16\"\n                      theme=\"fluency-systems-regular\"\n                      class=\"cursor-pointer opacity-50 hover:opacity-100\"\n                    ></smallstack-icon>\n                    <div\n                      tabindex=\"0\"\n                      class=\"!fixed dropdown-content z-50 p-2 shadow-lg bg-base-100 rounded flex flex-col gap-2 border input-bordered justify-start items-start\"\n                    >\n                      <ng-container *rxIf=\"listProperty.sortable\">\n                        <button (click)=\"sort(listProperty.property, 'asc')\" class=\"btn btn-xs btn-block\">\n                          Aufsteigend sortieren\n                        </button>\n                        <button (click)=\"sort(listProperty.property, 'desc')\" class=\"btn btn-xs btn-block\">\n                          Absteigend sortieren\n                        </button>\n                      </ng-container>\n                      <button (click)=\"filterBarVisible$.next(true)\" class=\"btn btn-xs w- btn-block\">filtern</button>\n                    </div>\n                  </div>\n                </div>\n              </div>\n              <div class=\"rx-table-header-cell w-1/12\" style=\"min-width: 120px\">Actions</div>\n            </div>\n          </div>\n          <!-- Filter Bar -->\n          <smallstack-form\n            [ngClass]=\"{ hidden: !(filterBarVisible$ | push) }\"\n            [schema]=\"filterSchema$ | push\"\n            [value]=\"filterSearch$ | push\"\n            [options]=\"{ compactMode: true, showLabel: false, showHint: false }\"\n            (valueChange)=\"filterSearch$.next($event)\"\n          >\n            <smallstack-form-custom-layout>\n              <div\n                class=\"flex flex-row w-full rx-table-row rx-table-filter-row\"\n                [ngStyle]=\"{ width: (containerWidth$ | push) }\"\n              >\n                <div class=\"rx-table-cell w-10 center-center\"></div>\n                <div *rxIf=\"hasSearchResults$\" class=\"rx-table-cell flex-[10]\"></div>\n                <div\n                  *rxFor=\"let lp of tableConfiguration.listProperties\"\n                  class=\"rx-table-cell max-sm:flex-auto\"\n                  [ngStyle]=\"{ flex: lp.width || 10 }\"\n                >\n                  <ng-container *ngIf=\"lp.filterable\" [schemaFormPlaceholder]=\"lp.property\"></ng-container>\n                </div>\n                <div class=\"rx-table-cell w-1/12\" style=\"min-width: 120px\">\n                  <button\n                    class=\"btn btn-warning btn-sm\"\n                    (click)=\"filterSearch$.next(undefined); filterBarVisible$.next(false)\"\n                    >Filter l\u00F6schen</button\n                  >\n                </div>\n              </div>\n            </smallstack-form-custom-layout>\n          </smallstack-form>\n          <div\n            *ngIf=\"tableData === undefined || tableData === null || tableData.length === 0\"\n            class=\"text-center text-help m-6\"\n          >\n            Keine Daten vorhanden\n          </div>\n          <rx-virtual-scroll-viewport\n            style=\"min-height: 200px\"\n            [ngStyle]=\"{ height: tableConfiguration.tableHeight }\"\n            [itemSize]=\"64\"\n          >\n            <div\n              *rxVirtualFor=\"let element of tableData; let index = index; trackBy: 'id'\"\n              class=\"flex flex-col md:flex-row w-full rx-table-row max-md:card max-md:card-bordered\"\n              data-test=\"table-row\"\n              #rxTableRow\n            >\n              <div class=\"hidden md:block checkboxes rx-table-cell w-10\">\n                <input\n                  type=\"checkbox\"\n                  class=\"checkbox checkbox-primary checkbox-sm\"\n                  [checked]=\"selectedIds.includes(element.id)\"\n                  (change)=\"toggleEntry(element.id, $event)\"\n                  attr.data-testid=\"checkbox-{{ index }}\"\n                />\n              </div>\n              <div *rxIf=\"hasSearchResults$\" class=\"hidden md:block text-center rx-table-cell flex-[10]\">\n                <span class=\"text-help\">{{ element.score }}</span>\n              </div>\n              <div\n                *rxFor=\"let lp of tableConfiguration.listProperties\"\n                class=\"rx-table-cell max-sm:flex-auto relative\"\n                [ngStyle]=\"{ flex: lp.width || 10 }\"\n              >\n                <div *ngIf=\"lp.filterable\" class=\"absolute right-0 inline-filter invisible\">\n                  <smallstack-icon\n                    (click)=\"setInlineFilter(lp.property, element)\"\n                    name=\"filter\"\n                    class=\"opacity-60 cursor-pointer\"\n                  ></smallstack-icon>\n                </div>\n                <div class=\"font-bold mb-1 md:hidden\">\n                  <smallstack-i18n [data]=\"lp.title\"></smallstack-i18n>\n                </div>\n                <ng-container [ngSwitch]=\"lp.renderer\">\n                  <ng-container *ngSwitchCase=\"'date'\">\n                    <smallstack-date\n                      [format]=\"lp.rendererDateFormat\"\n                      [timestamp]=\"element | jsonByPath: lp.property\"\n                      style=\"white-space: nowrap\"\n                    ></smallstack-date>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'duration'\">\n                    <smallstack-duration [duration]=\"element | jsonByPath: lp.property\"></smallstack-duration>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'icon'\">\n                    <smallstack-icon\n                      size=\"24\"\n                      [alias]=\"\n                        mappingArray[lp.property][element[lp.property]]\n                          ? mappingArray[lp.property][element[lp.property]]\n                          : lp.defaultIcon\n                      \"\n                    ></smallstack-icon>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'image'\">\n                    <smallstack-overlay #overlay>\n                      <div class=\"card card-bordered card-compact shadow-xl bg-white\">\n                        <div class=\"card-body\">\n                          <img [src]=\"element | jsonByPath: lp.property\" class=\"w-100\" />\n                        </div>\n                      </div>\n                    </smallstack-overlay>\n                    <img\n                      class=\"mask mask-square w-16 cursor-pointer\"\n                      [src]=\"element | jsonByPath: lp.property\"\n                      (click)=\"overlay.openOverlay()\"\n                    />\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'storeProperty'\">\n                    <smallstack-store-property\n                      [storeName]=\"lp.rendererStorePropertyStore\"\n                      [property]=\"lp.rendererStorePropertyProperty\"\n                      [modelId]=\"element | flatten: lp.property\"\n                    >\n                    </smallstack-store-property>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'i18n'\">\n                    <ng-container *ngIf=\"lp.i18nPrefix; else unPrefixed\">\n                      <smallstack-i18n\n                        [data]=\"(lp.i18nPrefix ? lp.i18nPrefix : '') + element | jsonByPath: lp.property\"\n                      ></smallstack-i18n>\n                    </ng-container>\n                    <ng-template #unPrefixed>\n                      <smallstack-i18n [data]=\"element | jsonByPath: lp.property\"></smallstack-i18n>\n                    </ng-template>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'qrCode'\">\n                    <button class=\"btn-action\" (click)=\"qrCodeDialog(element[lp.property], lp.qrCodePrefix)\">\n                      <smallstack-icon alias=\"qrcode\"></smallstack-icon>\n                    </button>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'dialog'\">\n                    <button class=\"btn-action\" (click)=\"openDialog(lp, element)\">\n                      <smallstack-icon [name]=\"lp.dialogButtonIcon\"></smallstack-icon>\n                    </button>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'link'\">\n                    <a\n                      href=\"{{ element | jsonByPath: lp.property }}\"\n                      target=\"{{ lp.openLinkInNewWindow ? '_blank' : undefined }}\"\n                    >\n                      <ng-container *ngIf=\"lp.linkLabel; else noLabel\">\n                        {{ lp.linkLabel }}\n                      </ng-container>\n                      <ng-template #noLabel>\n                        {{ element | jsonByPath: lp.property }}\n                      </ng-template>\n                    </a>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'boolean'\">\n                    <smallstack-icon\n                      name=\"checkmark--v1\"\n                      theme=\"color\"\n                      size=\"24\"\n                      *ngIf=\"(element | jsonByPath: lp.property) === true; else falsy\"\n                    >\n                    </smallstack-icon>\n                    <ng-template #falsy>\n                      <smallstack-icon name=\"delete-sign--v1\" theme=\"color\" size=\"24\"> </smallstack-icon>\n                    </ng-template>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'markdown'\">\n                    <smallstack-markdown-viewer [text]=\"element | jsonByPath: lp.property\"></smallstack-markdown-viewer>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'googleMap'\">\n                    <div style=\"cursor: pointer; position: relative\" (click)=\"overlay.openOverlay()\">\n                      <div style=\"position: absolute; width: 100%; height: 100%; z-index: 100\"></div>\n                      <google-map\n                        [width]=\"lp.googleMapsPreviewWidth\"\n                        [height]=\"lp.googleMapsPreviewHeight\"\n                        [zoom]=\"14\"\n                        [center]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                        [options]=\"{\n                          gestureHandling: 'none',\n                          disableDefaultUI: true,\n                          styles: [\n                            {\n                              featureType: 'poi',\n                              elementType: 'labels',\n                              stylers: [{ visibility: 'off' }]\n                            }\n                          ]\n                        }\"\n                      >\n                        <map-marker\n                          [position]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                          [clickable]=\"false\"\n                        ></map-marker>\n                      </google-map>\n                    </div>\n                    <smallstack-overlay #overlay>\n                      <mat-card class=\"flex flex-col space-y-5\">\n                        <google-map\n                          width=\"350px\"\n                          height=\"350px\"\n                          [zoom]=\"16\"\n                          [center]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                        >\n                          <map-marker\n                            [position]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                            [clickable]=\"false\"\n                          ></map-marker>\n                        </google-map>\n                        <button class=\"btn btn-primary\" (click)=\"overlay.closeOverlay()\">\n                          <smallstack-i18n data=\"@@actions.close\"></smallstack-i18n>\n                        </button>\n                      </mat-card>\n                    </smallstack-overlay>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'widget'\">\n                    <ng-container *ngIf=\"lp.widget\">\n                      <smallstack-widget-tree\n                        *ngIf=\"lp.widgetContextType === 'full'; else propertyContext\"\n                        [widget]=\"lp.widget\"\n                        (widgetChange)=\"setWidgetListProperty(lp.property, $event)\"\n                        [widgetRendererOptions]=\"{\n                          editMode$: widgetTreeService.editMode$\n                        }\"\n                        [context]=\"{ model: element }\"\n                        [globals]=\"{ model: element }\"\n                      ></smallstack-widget-tree>\n                      <ng-template #propertyContext>\n                        <smallstack-widget-tree\n                          [widget]=\"lp.widget\"\n                          (widgetChange)=\"setWidgetListProperty(lp.property, $event)\"\n                          [widgetRendererOptions]=\"{\n                            editMode$: widgetTreeService.editMode$\n                          }\"\n                          [context]=\"{ model: element | jsonByPath: lp.property }\"\n                          [globals]=\"{ model: element }\"\n                        ></smallstack-widget-tree\n                      ></ng-template>\n                    </ng-container>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'currency'\">\n                    <smallstack-currency\n                      [iso]=\"lp.currency ? lp.currency : 'EUR'\"\n                      [cents]=\"element[lp.property]\"\n                    ></smallstack-currency>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'valueMapping'\">\n                    <span>{{\n                      lp.mappingArray | objectArrayValue: \"value\":element[lp.property]:\"mappedValue\":lp.defaultValue\n                    }}</span>\n                  </ng-container>\n                  <ng-container *ngSwitchDefault>\n                    {{ element | flatten: lp.property | jsonstring }}\n                  </ng-container>\n                </ng-container>\n              </div>\n\n              <div class=\"flex flex-row gap-2 rx-table-cell w-1/12 flex-wrap items-center\" style=\"min-width: 120px\">\n                <ng-container *ngIf=\"data?.showDeleteButton\">\n                  <button\n                    class=\"btn-action btn-error\"\n                    [loadingFn]=\"deleteData(element)\"\n                    *showForPermission=\"(smallstackType$ | push)?.permissions?.delete\"\n                    data-test=\"delete-entry\"\n                  >\n                    <smallstack-icon alias=\"delete\"></smallstack-icon>\n                  </button>\n                </ng-container>\n                <ng-container *ngIf=\"data?.showEditButton\">\n                  <button\n                    class=\"btn-action btn-primary\"\n                    [loadingFn]=\"openEditor(element)\"\n                    *showForPermission=\"(smallstackType$ | push)?.permissions?.update\"\n                    data-test=\"edit-entry\"\n                  >\n                    <smallstack-icon alias=\"edit\"></smallstack-icon>\n                  </button>\n                </ng-container>\n                <smallstack-widget-child\n                  [(data)]=\"data\"\n                  property=\"actionWidget\"\n                  [context]=\"{ model: element }\"\n                  (dataChange)=\"dataChange.emit($event)\"\n                ></smallstack-widget-child>\n              </div>\n            </div>\n          </rx-virtual-scroll-viewport>\n        </div>\n        <div class=\"flex flex-row justify-between items-center w-full px-2 rx-table-actions\">\n          <!-- selected id actions -->\n          <div class=\"flex flex-row justify-start relative\">\n            <div\n              *rxIf=\"selectedIds.length === 0\"\n              class=\"absolute w-full h-full top-0 left-0 z-50 bg-white opacity-80 cursor-not-allowed\"\n            ></div>\n            <div *ngIf=\"data.allowMultiDelete\" class=\"flex flex-row justify-start items-center gap-2\">\n              <button\n                class=\"btn btn-error flex flex-row gap-1 items-center text-white\"\n                [loadingFn]=\"deleteManyData(selectedIds)\"\n                matTooltip=\"Markierte Datens\u00E4tze l\u00F6schen\"\n                *showForPermission=\"(smallstackType$ | push)?.permissions?.delete\"\n              >\n                <smallstack-icon\n                  alias=\"delete\"\n                  theme=\"fluency-systems-regular\"\n                  themeColor=\"daisyTheme.primary.textColor\"\n                ></smallstack-icon>\n                <smallstack-i18n data=\"@@actions.delete\"></smallstack-i18n>\n              </button>\n              <ng-container *rxIf=\"data.showExportButton !== false\">\n                <button\n                  class=\"btn btn-primary flex flex-row gap-1 items-center text-white\"\n                  [loadingFn]=\"exportData(selectedIds)\"\n                  matTooltip=\"Markierte Datens\u00E4tze exportieren\"\n                  *showForPermission=\"(smallstackType$ | push)?.permissions?.readAll\"\n                >\n                  <smallstack-icon\n                    name=\"export\"\n                    theme=\"fluency-systems-regular\"\n                    themeColor=\"daisyTheme.primary.textColor\"\n                  ></smallstack-icon>\n                  <smallstack-i18n data=\"@@actions.export\"></smallstack-i18n>\n                </button>\n              </ng-container>\n            </div>\n            <smallstack-widget-child\n              property=\"listActionsComponent\"\n              [(data)]=\"data\"\n              [context]=\"{selectedIds}\"\n              [widgetTags]=\"[WidgetTag.ICON, WidgetTag.CONTAINER]\"\n              (dataChange)=\"dataChange.emit($event)\"\n            ></smallstack-widget-child>\n          </div>\n          <!-- information -->\n          <div class=\"justify-center items-center text-help\" *rxLet=\"totalCount$; let totalCount\">\n            {{ totalCount }} Datens\u00E4tze insgesamt<span\n              *rxIf=\"totalCount !== tableData.length || hasSearchResults$ || filterSearch$\"\n            >\n              | {{ tableData.length }} Such-/ Filterergebnisse</span\n            ><span *ngIf=\"selectedIds?.length > 0\"> | {{ selectedIds.length }} markiert</span></div\n          >\n          <div class=\"flex flex-row gap-2\">\n            <button\n              class=\"btn btn-primary flex flex-row gap-1 items-center\"\n              [loadingFn]=\"reload(false)\"\n              (longPress)=\"reload(true)()\"\n              data-test=\"reload\"\n            >\n              <smallstack-icon\n                alias=\"refresh\"\n                theme=\"fluency-systems-regular\"\n                themeColor=\"daisyTheme.primary.textColor\"\n              ></smallstack-icon>\n              <smallstack-i18n data=\"@@actions.reload\"></smallstack-i18n>\n            </button>\n            <ng-container *showForPermission=\"(smallstackType$ | push)?.permissions?.create\">\n              <button\n                *ngIf=\"tableConfiguration?.showCreateButton !== false\"\n                class=\"btn btn-primary flex flex-row gap-1 items-center\"\n                [loadingFn]=\"openEditor()\"\n                data-test=\"create\"\n              >\n                <smallstack-icon\n                  alias=\"plus\"\n                  theme=\"fluency-systems-regular\"\n                  themeColor=\"daisyTheme.primary.textColor\"\n                ></smallstack-icon>\n                <smallstack-i18n data=\"@@actions.create\"></smallstack-i18n>\n              </button>\n            </ng-container>\n          </div>\n        </div>\n      </ng-container>\n    </ng-template>\n  </ng-container>\n</ng-container>\n<ng-template #widgetNotConfigured>\n  <div style=\"height: 60px\" class=\"flex flex-col justify-center items-center\">\n    <i><smallstack-i18n data=\"@@widgets.dataTable.errors.notConfiguredYet\"></smallstack-i18n></i>\n  </div>\n</ng-template>\n", styles: [".rx-table-header-cell{@apply p-2 pr-0 flex flex-row justify-start items-center overflow-hidden border-r border-r-white transition-all duration-500;}.rx-table-cell{overflow:hidden;flex-wrap:wrap;@apply p-2 h-16 flex items-center hover:bg-slate-100;}.rx-table-cell:hover .inline-filter{@apply visible;}.rx-table-row:nth-child(even){@apply bg-slate-50;}.rx-table-filter-row .rx-table-cell{@apply p-1;}.rx-table-filter-row ::ng-deep .input{@apply input-sm;}.rx-table-filter-row ::ng-deep .btn{@apply btn-sm;}.rx-table-filter-row ::ng-deep .dropdown-content{@apply fixed;}.rx-table-actions ::ng-deep .btn{@apply btn-sm;}.filter-bar-grid{display:grid;grid-template-columns:repeat(auto-fill,minmax(250px,1fr));grid-gap:10px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.MatLegacyDialog }, { type: i2.NotificationService }, { type: i3.RouterUtilService }, { type: i5.FrontendTypeRegistry }, { type: i3.BreakpointService }, { type: i1$1.RxCollectionService }, { type: i6.ViewportRuler }, { type: i3.FrontendSchemaService }, { type: i5$1.ActivatedRoute }]; }, propDecorators: { tableRows: [{
                type: ViewChildren,
                args: ["rxTableRow"]
            }] } });

export { DataTableV3WidgetComponent };
//# sourceMappingURL=smallstack-data-widgets-data-table-v3-widget.component-c4d8e404.mjs.map
